#!/bin/bash
# This will build BM_Map.exe using the g++ compiler.
# Tested with g++ v4.4.3 and 4.2.1
# (Note that this is using the openMP runtime library)

g++ -fopenmp -O2 -o BM_Map.exe *.cpp
if [ ! -e BM_Map.exe ]
then
    echo "---------------------------------------------------"
    echo "---------------------------------------------------"
    echo "Fail to compile!"
    echo "Do you have the right version of gcc?"
    echo "Please check README.txt"
    exit
else
    echo "Finish compiling!"
    if [ ! -d ForLinux_RunHere ]
    then
	echo "The directory 'ForLinux_RunHere' does not exist"
	echo "Please copy 'ForLinux_RunHere' into current directory and run the script again."
	exit
    else
	mv BM_Map.exe ./ForLinux_RunHere
	echo "Please cd to directory 'ForLinux_RunHere' and continue."
    fi
fi

#The input file(s) for the program must be present in ForLinux_Run also

