#ifndef CALC_ERROR_SCORE_H
#define CALC_ERROR_SCORE_H

#include "Read.h"
#include <map>
#include <vector>

/*calculate the error score based on tmpReads. 
	Each item in tmpReads has member varible sProfile: "IIIIIIII+I=IID<IIIIIE%2HH5$>I0.0?I9"
	Each item in tmpReads has member structure read, which stores mismatch position and the corresponding character
	error score= # of occurence that  character in sProfile being at mismatch position/ the total occurence of this character
	Each character and its error score is stored in error_profile.
*/
void calc_error_score( MultiReadVector & vUniqueReads,              // std::vector<TmpRead>& tmpReads, 
                       std::map<char, double>& error_profile  );

#endif
