// Combine_files.cpp 
//
#include <iostream>
#include <vector>
#include <stdio.h>
#include <string>
#include <fstream>
#include "YY_stopwatch.h"
#include "Combine_files.h"

using namespace std;


// ----------------------------------------------------------------------------
// Merge all input files and output the merged results to output file
void FileOperation::Merge( vector<string> & vInFilenames, string sOutputFilename )
{
	YY::Stopwatch stopWatch; double dStartTime= 0.0; stopWatch.start();
	//cout << endl << __FUNCTION__ << ": about to merge files." << endl;
	
   int count_out = 0;
	ofstream out(sOutputFilename.c_str());
	for(int i=0; i< vInFilenames.size(); i++)
	{
		int count_in = 0;
		ifstream in(vInFilenames[i].c_str());
		if(!in)
		{
			cout << __FUNCTION__ << ":  File (" << vInFilenames[i] << ") can not be opened." << endl;
		}
      else
      {
		   string line;
		   while( getline(in, line) )
		   {
			   count_in++;
			   out << line << endl;
		   }
		   in.close();
      }
		//cout << count_in << " lines were read from " << vInFilenames[i] << endl;
		count_out += count_in;
	}	
	out.close();
   //cout <<  count_out << " lines were written to " << sOutputFilename << endl;
	//cout << __FUNCTION__<< ": total time for combining results into " << sOutputFilename << ": " << (stopWatch.read()- dStartTime) << " seconds." << endl << endl;
}



// ----------------------------------------------------------------------------
// remove input files
void FileOperation::DeleteInputFiles( vector<string> & vInFilenames )
{
	for(int i=0; i<vInFilenames.size(); i++)
	{
		if( ::remove(vInFilenames[i].c_str())!=0 )
		{
			cout << __FUNCTION__ << ": error deleting " << vInFilenames[i] << endl;
		}
		else
		{
			//cout << __FUNCTION__<< ": " << vInFilenames[i] << " was successfully deleted." << endl;
		}
	}
}

