#ifndef _MAPFILEREADER_H
#define _MAPFILEREADER_H
#include <fstream>

#include "Read.h"

class MapFileReader
{
private:
    std::ifstream    _ioMapfile;
    std::string _sMapFilename;
    int         _iCurrentLineNum;   // Within the map/SAM file that we'll read.

    char  _chNewLine  ;

    int  TestStreamFlags( std::ios & x );

    void TrimSpaces( std::string & str );

    int ParseMismatchString( Read & myRead,                    // output  (populated and returned)
                             char const & sign,                // input    Like: '+' or '-'
                             std::string const & sMismatch_string   // Input, Example: "MD:Z:0C0A0G43" or "MD:Z:29A15T0"
                           ); 

public:

   // ctor:
   MapFileReader( ):  _chNewLine('\n')
   {  };

   bool OpenFile() ;
   void CloseFile() {_ioMapfile.close();};
   bool SetFileName( std::string const & sFilename);
   int  TestStreamFlags( );

   bool Read_a_Line( Read & read,
                     int & iNumLinesRejected  // Output: Number of lines from the file that we reject)    
                   );

   bool GetSequenceLenFromFile   ( std::string & sErrors );
   bool GetSequenceLenFromSAMFile( std::string & sErrors );
};



#endif
