#ifndef _THREAD_DATA_MGR_H
#define _THREAD_DATA_MGR_H

#include <vector>
#include "BMTypes.h"

// ------------------------------------------------------------
class ThreadDataMgr
{
public:
   std::vector<JobInfo*>  _vJobInfos;

   int PopulateJobInfoVector(
                          int const iStartIndex, int const iEndIndex,   // input
                          int const iNumJobs   , int const iN_loci ,    // input
                          int const iPart                               // input: Just used for formatting the filenames
                         );
   void MergeOutputFiles();

public:
   virtual ~ThreadDataMgr()
   {
      for(size_t i = 0;  i< _vJobInfos.size(); ++i)
      {
            delete _vJobInfos[i]->posCallRecStream;
            delete _vJobInfos[i]->posPostMeanStream;
            delete _vJobInfos[i];
      }
   }

};

#endif


