//
// DISTSAMPLING.H
//

#ifndef DISTSAMPLING_H
#define DISTSAMPLING_H 1

#include <vector>

#include "BMTypes.h"
#include "SimpleRNG.h"




// ----------------------------------------------------------------------------
// Distribution Sampling
class DistSampler
{
   // Note leading underscore ("_") on names indicating member variables.
private:
   SimpleRNG _rng;

public:
   double runif(  );                           //double startv, double endv, SEED_TYPE* iSeed );

   double rgamma(double shape, double rate );  //, SEED_TYPE* iSeed);

   double rbeta(double alpha, double beta );   //, SEED_TYPE* iSeed);



};



#if(0)
extern void cholesky(
                      std::vector<std::vector<double> >& a);
extern void rdirichlet(
                      std::vector<int>& nk,
                      std::vector<double>& d,
                      SEED_TYPE* idum);
extern double rnorm(
                      double mu,
                      double sd,
                      SEED_TYPE* idum);
extern int sample(
                      const std::vector<double>& p,
                      SEED_TYPE* idum);
#endif


#endif // DISTSAMPLING_H

