#ifndef FIND_MISMATCH_H
#define FIND_MISMATCH_H
#include"Read.h"

// ----------------------------------------------------------------------------
// return a three dimensional array which shows the mismatches in "1" and "0"
// elsewhere by extracting the information from multireads vector
// the original data.
//                                                                                         
// 'v' is a vector with each <MultiReads*> entry having n_loci members of reads
// And following is what Read structure looks like:
//   sID[sID_LEN];                  // Read ID:   "SRR002058.14857:1:2:481:128"
//   sChrom[sCHROM_LEN];            // Chromosome: "chr15"
//   iPosition;                     // Position of this Read within the genome  (0 to 2 billion)
//	iMisMatchPos[iMISMATCH_LEN];   // Positions of the mismatches in the SEQ_LEN (0 to 35 usually; we'll set it to -1 when it is 'NA' in our datafile.)
//	sProfile[sPROFILE_LEN];        // Mismatch profile: "IIIIIIII+I=IID<IIIIIE%2HH5$>I0.0?I9"
   
//   MisMatchItem  vMisMatches[iMISMATCH_LEN];   // stores mismatch position and the character presenting at that position
//	 int NumMisMatches( ) //return number of mismatches
//	 bool MisMatchOccursAtAbsolutePos( int iAbsPosition )

bool *** find_mismatch( MultiReadVector & v);

#endif
