


#include <algorithm>
#include <cassert>
#include <climits>
#include <cmath>
#include <cstdio>
#include <cstdlib>
#include <ctime>
#include <iostream>
#include <iomanip>
#include <fstream>
#include <sstream>
#include <stdexcept>
#include <string>
#include <vector>

using namespace std;

#include "utils.h"    // This include Logger.h


namespace  // anonymous
{
   Logger g_Logger;
};

// ------------------------------------------------------
Logger & GetLogger()
{
   return g_Logger;
}




// ----------------------------------------------------------------------------
//print out string vector
void print_v(vector<string> v)
{
    size_t size=v.size();
    for (int i = 0; i < (int)size; i++)
    {
        cout << i << '\t' << v[i] << endl;
    }
}


// ----------------------------------------------------------------------------
//print out string array vector
void print_vv(vector<string*> v,
              int col)
{
    size_t size = v.size();
    for (int i = 0; i < (int)size; i++)
    {
        cout << i << '\t'
             << v[i][0] << " ";
        for (int j = 6; j < col; j++)
        {
            cout << v[i][j] << " ";
        }
        cout << endl;
    }
}


// ----------------------------------------------------------------------------
//print a 3-dimensional int array
void print_array(int*** A,
                 int x,
                 int y,
                 int z)
{
    for (int i = 0; i < x; i++)
    {
        cout << i << endl;
        for (int j = 0; j < y; j++)
        {
            cout << j << '\t';
            for (int k = 0; k < z; k++)
            {
                cout << A[i][j][k] << " ";
            }
            cout << endl;
        }
        cout << endl;
    }
}


// ----------------------------------------------------------------------------
/*
string convertS(double d)
{
    ostringstream o;
    o << d;
    return o.str();
}
*/


// ----------------------------------------------------------------------------


/*
string convertS(int i, int digit)
{
  ostringstream o;
  o<<i;
  string s=o.str();
  if(s.size()!=digit)
    {
      while(s.size()<digit)
	{
	  s="0"+s;
	}
    }  
  return s;
}
*/


string convertS(int i, int width)
{
   assert(width >= 0);
   std::ostringstream o;
   o << setfill('0') << setw(width) << internal << i;
   return o.str();
}




// ----------------------------------------------------------------------------
//find the minimum value of a vector
int min_value(vector<int>  const & A ) //,  // int A[],  int size)
{
#if 0
    int minimum = A[0];
    for (int i = 1; i < size; i++)
    {
        if (A[i] < minimum)
        {
            minimum = A[i];
        }
    }

    return minimum;
#else
    return *std::min_element(A.begin(), A.end());   //(A, A+size);
#endif
}

