#ifndef UTILS_H
#define UTILS_H

#include <vector>
#include "Logger.h"
using namespace std;


// ------------------------------------------------------
Logger & GetLogger();




// ------------------------------------------------------
void print_v(vector<string> v);

void print_vv(vector<string*> v, int col);

//print a 3-dimensional int array
void print_array(int*** A,
                 int x,
                 int y,
                 int z);


string convertS(int i, int width);

int min_value(vector<int>  const & A );


template<typename T>
std::string convertS(T i)
{
    ostringstream o;
    o << i;
    return o.str();
}

template<typename T>
void Make2DArray( T **(& A), size_t nRows, size_t nCols)
{   
   A = new T*[nRows];
   for (size_t r = 0; r < nRows; ++r)
   {
      A[r] = new T[nCols];
   }
 }

template<typename T>
void Delete2DArray( T **(& A), size_t nRows )
{   
   for (size_t r = 0; r < nRows; ++r)
   {
      delete [] A[r];
   }
   delete [] A;
   A = 0;
 }


typedef struct
{
  int    iPosWithinRead; // Relative position of this char within the SEQ_LEN.  Like: between 0 and SEQ_LEN-1  (SEQ_LEN is 35 for yeast)
  bool   boMisMatch;     // True if iPosWithinRead is flagged as a MisMatch (is one of positions listed as a MisMatch).
  //string sProfile;       // Profile of mismatch probability indicators:  Like: "DLDPTTHHHVGPPGTPVTPVVVVVVVVVVVVVVTVV", only the character at mismatch position is needed.
  char cMis;             // The character present at position: iPosWithinRead in sProfile.
} MisMatchData;

#endif

